import { Encode, readLinkObject, _getListLink } from "../logic/Encode";
import { readLinkObjectAsync as readLinkObjectAsyncDefault, _getListLinkAsync as _getListLinkAsyncDefault } from "./api-async-defaults";
import { Promisy } from "./Promisy";
declare const _default: {
    new (...args: any[]): {
        $: import("vue").ComponentInternalInstance;
        $data: {};
        $props: Partial<{
            readLinkObjectAsync: Promisy<typeof readLinkObject>;
            _getListLinkAsync: Promisy<typeof _getListLink>;
        }> & Omit<Readonly<import("vue").ExtractPropTypes<__VLS_WithDefaults<__VLS_TypePropsToRuntimeProps<{
            data: ReturnType<typeof Encode>;
            type?: "warn" | "output" | "error" | "info" | "debug" | "log" | undefined;
            _getListLinkAsync: Promisy<typeof _getListLink>;
            readLinkObjectAsync: Promisy<typeof readLinkObject>;
        }>, {
            _getListLinkAsync: typeof _getListLinkAsyncDefault;
            readLinkObjectAsync: typeof readLinkObjectAsyncDefault;
        }>>> & import("vue").VNodeProps & import("vue").AllowedComponentProps & import("vue").ComponentCustomProps, "readLinkObjectAsync" | "_getListLinkAsync">;
        $attrs: {
            [x: string]: unknown;
        };
        $refs: {
            [x: string]: unknown;
        };
        $slots: Readonly<{
            [name: string]: import("vue").Slot | undefined;
        }>;
        $root: import("vue").ComponentPublicInstance<{}, {}, {}, {}, {}, {}, {}, {}, false, import("vue").ComponentOptionsBase<any, any, any, any, any, any, any, any, any, {}>> | null;
        $parent: import("vue").ComponentPublicInstance<{}, {}, {}, {}, {}, {}, {}, {}, false, import("vue").ComponentOptionsBase<any, any, any, any, any, any, any, any, any, {}>> | null;
        $emit: (event: string, ...args: any[]) => void;
        $el: any;
        $options: import("vue").ComponentOptionsBase<Readonly<import("vue").ExtractPropTypes<__VLS_WithDefaults<__VLS_TypePropsToRuntimeProps<{
            data: ReturnType<typeof Encode>;
            type?: "warn" | "output" | "error" | "info" | "debug" | "log" | undefined;
            _getListLinkAsync: Promisy<typeof _getListLink>;
            readLinkObjectAsync: Promisy<typeof readLinkObject>;
        }>, {
            _getListLinkAsync: typeof _getListLinkAsyncDefault;
            readLinkObjectAsync: typeof readLinkObjectAsyncDefault;
        }>>>, {}, unknown, {}, {}, import("vue").ComponentOptionsMixin, import("vue").ComponentOptionsMixin, Record<string, any>, string, {
            readLinkObjectAsync: Promisy<typeof readLinkObject>;
            _getListLinkAsync: Promisy<typeof _getListLink>;
        }> & {
            beforeCreate?: ((() => void) | (() => void)[]) | undefined;
            created?: ((() => void) | (() => void)[]) | undefined;
            beforeMount?: ((() => void) | (() => void)[]) | undefined;
            mounted?: ((() => void) | (() => void)[]) | undefined;
            beforeUpdate?: ((() => void) | (() => void)[]) | undefined;
            updated?: ((() => void) | (() => void)[]) | undefined;
            activated?: ((() => void) | (() => void)[]) | undefined;
            deactivated?: ((() => void) | (() => void)[]) | undefined;
            beforeDestroy?: ((() => void) | (() => void)[]) | undefined;
            beforeUnmount?: ((() => void) | (() => void)[]) | undefined;
            destroyed?: ((() => void) | (() => void)[]) | undefined;
            unmounted?: ((() => void) | (() => void)[]) | undefined;
            renderTracked?: (((e: import("vue").DebuggerEvent) => void) | ((e: import("vue").DebuggerEvent) => void)[]) | undefined;
            renderTriggered?: (((e: import("vue").DebuggerEvent) => void) | ((e: import("vue").DebuggerEvent) => void)[]) | undefined;
            errorCaptured?: (((err: unknown, instance: import("vue").ComponentPublicInstance<{}, {}, {}, {}, {}, {}, {}, {}, false, import("vue").ComponentOptionsBase<any, any, any, any, any, any, any, any, any, {}>> | null, info: string) => boolean | void) | ((err: unknown, instance: import("vue").ComponentPublicInstance<{}, {}, {}, {}, {}, {}, {}, {}, false, import("vue").ComponentOptionsBase<any, any, any, any, any, any, any, any, any, {}>> | null, info: string) => boolean | void)[]) | undefined;
        };
        $forceUpdate: () => void;
        $nextTick: typeof import("vue").nextTick;
        $watch(source: string | Function, cb: Function, options?: import("vue").WatchOptions<boolean> | undefined): import("vue").WatchStopHandle;
    } & Readonly<import("vue").ExtractPropTypes<__VLS_WithDefaults<__VLS_TypePropsToRuntimeProps<{
        data: ReturnType<typeof Encode>;
        type?: "warn" | "output" | "error" | "info" | "debug" | "log" | undefined;
        _getListLinkAsync: Promisy<typeof _getListLink>;
        readLinkObjectAsync: Promisy<typeof readLinkObject>;
    }>, {
        _getListLinkAsync: typeof _getListLinkAsyncDefault;
        readLinkObjectAsync: typeof readLinkObjectAsyncDefault;
    }>>> & import("vue").ShallowUnwrapRef<{}> & {} & import("vue").ComponentCustomProperties;
    __isFragment?: undefined;
    __isTeleport?: undefined;
    __isSuspense?: undefined;
} & import("vue").ComponentOptionsBase<Readonly<import("vue").ExtractPropTypes<__VLS_WithDefaults<__VLS_TypePropsToRuntimeProps<{
    data: ReturnType<typeof Encode>;
    type?: "warn" | "output" | "error" | "info" | "debug" | "log" | undefined;
    _getListLinkAsync: Promisy<typeof _getListLink>;
    readLinkObjectAsync: Promisy<typeof readLinkObject>;
}>, {
    _getListLinkAsync: typeof _getListLinkAsyncDefault;
    readLinkObjectAsync: typeof readLinkObjectAsyncDefault;
}>>>, {}, unknown, {}, {}, import("vue").ComponentOptionsMixin, import("vue").ComponentOptionsMixin, Record<string, any>, string, {
    readLinkObjectAsync: Promisy<typeof readLinkObject>;
    _getListLinkAsync: Promisy<typeof _getListLink>;
}> & import("vue").VNodeProps & import("vue").AllowedComponentProps & import("vue").ComponentCustomProps & (new () => {
    $slots: {};
});
export default _default;
declare type __VLS_NonUndefinedable<T> = T extends undefined ? never : T;
declare type __VLS_TypePropsToRuntimeProps<T> = {
    [K in keyof T]-?: {} extends Pick<T, K> ? {
        type: import('vue').PropType<__VLS_NonUndefinedable<T[K]>>;
    } : {
        type: import('vue').PropType<T[K]>;
        required: true;
    };
};
declare type __VLS_WithDefaults<P, D> = {
    [K in keyof Pick<P, keyof P>]: K extends keyof D ? P[K] & {
        default: D[K];
    } : P[K];
};
